﻿using ProjectTank.Drawnings;
using ProjectTank.Entities;
using System;

namespace ProjectTank.CollectionGenericObjects;

/// <summary>
/// Реализация абстрактной компании - аренда поезда 
/// </summary>
public class TankBase : AbstractCompany
{
    /// <summary>
    /// Конструктор
    /// </summary>
    /// <param name="picWidth"></param>
    /// <param name="picHeight"></param>
    /// <param name="collection"></param>
    public TankBase(int picWidth, int picHeight, ICollectionGenericObjects<DrawningTank2> collection) : base(picWidth, picHeight, collection)
    {
    }

    protected override void DrawBackgound(Graphics g)
    {
        Pen pen = new(Color.Black);
        for (int i = 0; i < _pictureWidth / _placeSizeWidth; i++)
        {
            for (int j = 0; j < _pictureHeight / _placeSizeHeight; j++)
            {
                g.DrawLine(pen, new(_placeSizeWidth * i, _placeSizeHeight * j), new((int)(_placeSizeWidth * (i + 0.5f)), _placeSizeHeight * j));
                g.DrawLine(pen, new(_placeSizeWidth * i, _placeSizeHeight * j), new(_placeSizeWidth * i, _placeSizeHeight * (j + 1)));
            }
            g.DrawLine(pen, new(_placeSizeWidth * i, _placeSizeHeight * (_pictureHeight / _placeSizeHeight)), new((int)(_placeSizeWidth * (i + 0.5f)), _placeSizeHeight * (_pictureHeight / _placeSizeHeight)));
        }


    }

    protected override void SetObjectsPosition()
    {
        int n = 0;
        for (int i = 0; i < _pictureWidth / _placeSizeWidth; i++)
        {
            for (int j = 0; j < _pictureHeight / _placeSizeHeight; j++)
            {
                DrawningTank2? drawningTank2 = _collection?.Get(n);
                n++;
                if (drawningTank2 != null)
                {
                    drawningTank2.SetPictureSize(_pictureWidth, _pictureHeight);
                    drawningTank2.SetPosition(i * _placeSizeWidth + 5, j * _placeSizeHeight + 5);
                }
            }
        }
    }
}