﻿using ProjectTank.Entities;

namespace ProjectTank.Drawnings;
/// <summary>
/// Класс, отвечающий за прорисовку и перемещение объекта-сущности
/// </summary>
public class DrawningTank : DrawningTank2
{
    /// <summary>
    /// Конструктор
    /// </summary>
    /// <param name="speed">Скорость</param>
    /// <param name="weight">Вес автомобиля</param>
    /// <param name="bodyColor">Основной цвет</param>
    /// <param name="additionalColor">Дополнительный цвет</param>  
    /// <param name="gunTurret">Признак наличия башни с орудием</param>  
    /// <param name="machineGun">Признак наличия пулемёта</param>  
    public DrawningTank(int speed, double weight, Color bodyColor, Color additionalColor, bool gunTurret, bool machineGun) : base(200, 100)
    {
        EntityTank2 = new EntityTank(speed, weight, bodyColor, additionalColor, gunTurret, machineGun);
    }

    public override void DrawTransport(Graphics g)
    {
        if (EntityTank2 == null || EntityTank2 is not EntityTank tank || !_startPosX.HasValue || !_startPosY.HasValue)
        {
            return;
        }

        Pen pen = new(Color.Black);
        Brush additionalBrush = new SolidBrush(tank.AdditionalColor);



        _startPosX += 37;
        _startPosY += 0;
        base.DrawTransport(g);
        _startPosX -= 37;
        _startPosY -= 0;

        if (tank.GunTurret)
        {
            g.DrawRectangle(pen, _startPosX.Value, _startPosY.Value + 17, 85, 8);
            g.FillRectangle(additionalBrush, _startPosX.Value, _startPosY.Value + 17, 85, 8);
        }

        if (tank.MachineGun)
        {
            g.DrawRectangle(pen, _startPosX.Value + 101, _startPosY.Value + 3, 24, 12);
            g.DrawRectangle(pen, _startPosX.Value + 109, _startPosY.Value + -14, 5, 18);
            g.DrawRectangle(pen, _startPosX.Value + 91, _startPosY.Value + -12, 19, 5);

            g.FillRectangle(additionalBrush, _startPosX.Value + 101, _startPosY.Value + 3, 24, 12);
            g.FillRectangle(additionalBrush, _startPosX.Value + 109, _startPosY.Value + -14, 5, 18);
            g.FillRectangle(additionalBrush, _startPosX.Value + 91, _startPosY.Value + -12, 19, 5);

        }




    }
}
