﻿using ProjectTank.Entities;

namespace ProjectTank;

/// <summary>
/// Класс-сущность "Танк"
/// </summary>
public class EntityTank : EntityTank2
{
    public EntityTank(int speed, double weight, Color bodyColor) : base(speed, weight, bodyColor)
    {
    }
    
    /// <summary>
    /// Дополнительный цвет (для опциональных элементов)
    /// </summary>
    public Color AdditionalColor { get; private set; }
    /// <summary>
    /// Признак (опция) наличия башни с орудием
    /// </summary>
    public bool GunTurret { get; private set; }
    /// <summary>
    /// Признак (опция) наличия пулемёта
    /// </summary>
    public bool MachineGun { get; private set; }
    /// <summary>
    /// Инициализация полей объекта-класса спортивного автомобиля
    /// </summary>
    /// <param name="speed">Скорость</param>
    /// <param name="weight">Вес автомобиля</param>
    /// <param name="bodyColor">Основной цвет</param>
    /// <param name="additionalColor">Дополнительный цвет</param>  
    /// <param name="gunTurret">Признак наличия башни с орудием</param>  
    /// <param name="machineGun">Признак наличия пулемёта</param>  
    public EntityTank(int speed, double weight, Color bodyColor, Color
    additionalColor, bool gunTurret, bool machineGun) : base(speed, weight, bodyColor)
    {
        
        AdditionalColor = additionalColor;
        GunTurret = gunTurret;
        MachineGun = machineGun;
    }
}
public class MyClass
{
    private int PrivateField;

    public int PublicProperty { private get; set; }

    public void PublicMethod()
    {
        // Код метода
    }
}